// ___SETA43  _____
// 10/03/2025 _____
//RELOJ DS1307
//Temperatura-Humedad  AHT20
//Presion BMP280
//Arduino 1.8.19
// seta43.duckdns.org
// seta43.blogspot.com

//En arduino NANO:       A4(SDA), A5(SCL)
//https://i2cdevices.org/addresses

#include <Wire.h>

//EEPROM AT24C32
#define addressI2C   0x50 


#include <AHT20.h>

#include "RTClib.h"
RTC_DS1307 rtc;

#include <BMP280.h>
BMP280 bmp280;
#define PRESION_MAR   1023  //Palencia capital (España)
/////////////////////////////////////////////////////////////////
//___________OLED_________
#include "olex.h"
#include <Wire.h>
/////////////////////////////////////////////////////////////////

char segundo,minuto,hora,dia,mes;
long anio; //variable año
DateTime HoraFecha;

char Nombres[8][7]= {"*","DIA  ", "MES  ", "YEAR  ", "HORA ", "MIN. ",  "SEG. "};

char segundoOld,diaOld;
char cadena[40];

AHT20 aht20;
float temperatura=0;
float humedad=0;

uint32_t P_bmp280=0;
float T_bmp280=0;
int altitud;

int zTem,xHum;

int pre0,pre1;
int zTem280;

#define BUTTON_PIN  2
#define BUTTON_INC  3

int modo = 0; 


#define TAMANO 10
char entrada[TAMANO];
boolean stringComplete = false;
int contador;
//char buffer[TAMANO];

char nombre[]="SETA43 RELOJ1307";

void setup()
{
  Serial.begin(115200);
  pinMode(BUTTON_PIN, INPUT_PULLUP); 
  pinMode(BUTTON_INC, INPUT_PULLUP); 
  Serial.println(nombre);

  Wire.begin(); // I2C bus
  scanI2C();

  if (aht20.begin() == false) { Serial.println("No AHT20 "); while (1); }
  delay(200);
  if (rtc.begin() == false) { Serial.println("No RTC "); while (1); }
  delay(200);
  if (bmp280.begin() != false) { Serial.println("No BMP280 "); while (1); }
  
  delay(200);
  OleInit();
  delay(100); 
  xclearDisplay(); 
  ModeFont=0; xStringAT(0,0,(char *)nombre); 
  delay(500); 
}

void loop()
{
  delay(10);
   while (Serial.available())
      {
        char inChar = (char)Serial.read();
        entrada[contador] = inChar;
        if (inChar == 13 || inChar == 10)
          {
            stringComplete = true;
            entrada[contador] = 0;
          }
        if(contador<TAMANO-1) contador++;
      }

  if (stringComplete)
    {
     contador = 0;
     stringComplete = false;
     for(char z=0;z<TAMANO;z++) if(entrada[z]>96 && entrada[z]<123) entrada[z]-=32;  //minúsculas a mayusculas
     Orden(entrada);
    }



   if(modo==0)
     {
      HoraFecha = rtc.now(); //obtenemos la hora y fecha actual 
      segundo=HoraFecha.second();
      if(segundo!=segundoOld)
        {  
          //digitalWrite(13, !digitalRead(13));
          digitalWrite(13,0);
          segundoOld=segundo;
          minuto=HoraFecha.minute();
          hora=HoraFecha.hour();
          dia=HoraFecha.day();
          mes=HoraFecha.month();
          anio=HoraFecha.year();
         
          printDate();  
          printTimeOLED();

          if(dia!=diaOld) { printDateOLED(); }

          if((segundo%5)==0)
            {  digitalWrite(13,1); getData();  printData(); prinDataOLED(); }
           else
            {  Serial.println("");  }
        
          if(segundo==0 && (minuto==0 || minuto==15 || minuto==30 || minuto==45) )
            {
              guardarData2((minuto/15)*4+hora*16); 
              //4 byte/toma * 4 tomas/hora * 24 horas=384 tomas/dia
            }                  
          
         }
      }
      
     if (digitalRead(BUTTON_PIN) == 0) 
        {     
          delay(100);
          while(digitalRead(BUTTON_PIN) == 0) {;}
          modo = modo + 1;
          if (modo > 6) 
              { 
                modo = 0;
                rtc.adjust(DateTime(anio, mes, dia, hora, minuto, segundo));
                xclearDisplay();
              }
          sprintf(cadena,"CAMBIO %s",Nombres[modo]);
          Serial.println(cadena);
          printTimeOLED();
        }
        
     if (digitalRead(BUTTON_INC) == 0) 
        {  
          delay(100);
          while(digitalRead(BUTTON_INC) == 0) {;}
          switch(modo)
                {
                  case 0:
                      sprintf(cadena,">>>%02d:%02d:%02d   %02d/%02d/%02d",hora,minuto,segundo,dia,mes,anio);
                      Serial.println(cadena);
                  break;
                  case 1:
                      dia++;
                      if(dia>31)dia=1;
                  break;
                  case 2:
                      mes++;
                      if(mes>12)mes=1;
                  break;
                  case 3:
                      anio++;
                      if(anio>50) anio=20;
                  break;
                  case 4:       
                     hora++;
                     if(hora>23)hora=0;
                  break;
                  case 5:       
                     minuto++;
                     if(minuto>59) minuto=0;
                  break;
                  case 6:
                    segundo++;       
                    if(segundo>59)segundo=0;
                  break;
                }
              printDate(); Serial.println("");
              printTimeOLED();
        }     
}

//------------------------------------------

void Orden(char *bufferS)
{ 
      runFuniones();
}  

void runFuniones(void)
{
  if(strstr(entrada,"PRINT") )
      {
        leerData2(96); //tomas/dia
        goto salir0;
      }
  Serial.println("aERROR ");
salir0:
 ;
}


//---------------------------------

void getData(void)
{
    P_bmp280 = bmp280.getPressure();
    T_bmp280 = bmp280.getTemperature();
    delay(50);
    temperatura = aht20.getTemperature();
    humedad= aht20.getHumidity();
    delay(50);  
}


void printDate(void)
{
    if(modo!=0)    { sprintf(cadena,"CAMBIO %s",Nombres[modo]);   Serial.print(cadena); }  
    sprintf(cadena,"%02d:%02d:%02d %02d/%02d/%02d ",hora,minuto,segundo,dia,mes,anio);
    Serial.print(cadena);
}

void printData(void)
{
 char signo;
  zTem=float(temperatura*100);
  xHum=float(humedad*10);
  if(zTem<0)  { zTem*=-1; signo='-';} else {signo='+';}
  sprintf(cadena,"AHT20=%c%02i.%02dC %02i.%01d%%HR ",signo,zTem/100,zTem%100,xHum/10,xHum%10);
  Serial.print(cadena);
//==================================
  zTem280=float(T_bmp280*100);
  pre0=P_bmp280/100;
  pre1=P_bmp280%100;
  altitud=bmp280.calAltitude(P_bmp280,PRESION_MAR);

  if(zTem280<0) { zTem280*=-1; signo='-';}  else { signo='+';}
  sprintf(cadena,"BMP=%c%02i.%02dC %i.%02dPa %dM",signo,zTem280/100,zTem280%100,pre0,pre1,altitud);
  Serial.println(cadena);
}


void guardarData2(int dir)
{
 int t,pp;
 byte h,p;

    t=float(temperatura)*100;
    h=float(humedad);
    pp=float(P_bmp280/100);
    pp=1128-pp;
    p=pp;
     
    wEeprom(addressI2C,dir,t/100);
    wEeprom(addressI2C,dir+1,t%100);
    wEeprom(addressI2C,dir+2,h);
    wEeprom(addressI2C,dir+3,p);
    
    sprintf(cadena,"save*T/H/P toma=%04d %02d.%02d %03d:%03d ",dir/3,t/100,t%100,h,p);
    Serial.println(cadena);
}


void leerData2(int tomas)
{
  int dir,num;
  byte t,t1,h,p;
    Serial.println(F("---Print data---"));
    Serial.println(F("Hora  DIA-MES TEM. HUM. PRE."));
    for(num=0;num<tomas;num++)
      {
        dir=num*4;
        t=rEeprom(addressI2C,dir);
        t1=rEeprom(addressI2C,dir+1);
        h=rEeprom(addressI2C,dir+2);
        p=rEeprom(addressI2C,dir+3); 
        sprintf(cadena,"HORA=%d %04d %02d.%02d %03d %03u ",dir/16,num, t,t1,h,1128-p);
        Serial.println(cadena);   
      }
    Serial.print("--bytes="); Serial.println(num*4);
}

//---------------------------
void printDateOLED(void)
{
  sprintf(cadena,"%02d/%02d/%02d",dia,mes,anio);
  xStringAT(0,3,(char *) cadena);
}

void printTimeOLED(void)
{
  ModeFont=2; 
  sprintf(cadena," %02d:%02d:%02d",hora,minuto,segundo);
  xStringAT(0,0,(char *)cadena);

  if(modo!=0) 
  {   
    printDateOLED();
    sprintf(cadena,"->%s  ",Nombres[modo]);
    xStringAT(0,6,(char *)cadena);
  }
  
}

void prinDataOLED(void)
{
 char signo;
  if(modo==0)
  {
  ModeFont=3; 
  sprintf(cadena,"%04i.%02i Pa  %d M ",pre0,pre1,altitud);
  xStringAT(0,6,(char *) cadena);
  
  if(zTem<0)  { zTem*=-1; signo='-';} else {signo='+';}
  sprintf(cadena,"%c%02i.%02i%cC  %02i.%01d%% HR ",signo,zTem/100,zTem%100,127,xHum/10,xHum%10);
  xStringAT(0,7,(char *) cadena);
  }
  
}



void scanI2C() 
{
  int nDevices = 0;

  Serial.println(F("Scanning..."));

  for (byte address = 1; address < 127; ++address) {

    Wire.beginTransmission(address);
    byte error = Wire.endTransmission();

    if (error == 0) 
      {
        Serial.print(nDevices);
        Serial.print(F("-I2C device found at address 0x"));
        if (address < 16) {   Serial.print("0");  }
        Serial.print(address, HEX); 
        switch(address)
        {
          case 0x38:
            Serial.println(F(" AHTxx"));
          break;
          case 0x3C:
            Serial.println(F(" OLED"));
          break;
          case 0x50:
            Serial.println(F(" AT24C32"));
          break;
           case 0x68:
            Serial.println(F(" DS1371"));
          break;
           case 0x77:
            Serial.println(F(" BMP280"));
          break;
          default:
          Serial.println(F(" ¿Desconocido?"));
          break;
        }
  
        ++nDevices;
      } 
      else 
        if (error == 4) 
        {
        Serial.print(F("Unknown error at address 0x"));
        if (address < 16) {  Serial.print("0"); }
        Serial.println(address, HEX);
        }
      }
    if (nDevices == 0) 
      {  Serial.println(F("No I2C devices found\n")); } 
     else 
      {  Serial.println(F("done\n"));  }
}


//==========EEPROM i2C===============

void wEeprom(int dirI2C,unsigned int dir,byte dato)
{
  //WRITE!!!!*******************************
    Wire.beginTransmission(dirI2C);
    Wire.write((dir>>8)&0xFF);      //First Word Address
    Wire.write(dir&0xFF);      //Second Word Address
    
    Wire.write(dato);      //Write an 'A'    
    delay(10);   
    Wire.endTransmission();
    delay(10);
}

unsigned char rEeprom(int dirI2C,byte dir)
{
 //READ!!!!*********************************
    Wire.beginTransmission(dirI2C);
    Wire.write((dir>>8)&0xFF);      //First Word Address
    Wire.write(dir&0xFF);      //Second Word Address
    Wire.endTransmission();
    delay(10);
    
    Wire.requestFrom(dirI2C, 1);
    //delay(10);
    return(Wire.read()); 
}
